searchNodes=[{"doc":"Getting Started Easily run Elixir integration tests with docker-compose. Provide Divo with docker-compose configuration, add use Divo to your integration tests, and run with mix test.integration . Installation The package can be installed by adding divo to your list of dependencies in mix.exs : def deps ( ) do [ { :divo , &quot;~&gt; 2.0.0&quot; , only : [ :dev , :integration ] } ] end The docs can be found at https://hexdocs.pm/divo . New versions are published with actions upon github release. Configuration Docker Define services in your mix configuration file to define the dockerized service(s) you want to run as a dependency of your Elixir app. Define divo config in one of the following three ways: Method 1 - Compose file In your config, include the path to the yaml or json-formatted compose file #config/config.exs config :myapp , divo : &quot; test / support / docker - compose . yaml , divo_wait : [ dwell : 700 , max_tries : 50 ] #test/support/docker-compose.yaml version: '3' services: redis: image: redis ports: - &quot;6379:6379&quot; healthcheck: test: [&quot;CMD&quot;, &quot;redis-cli&quot;, &quot;PING&quot;] interval: 5s timeout: 10s retries: 3 Method 2 - Pre-existing module In your mix file, include the additional dependency #mix.exs def deps ( ) do [ { :divo , &quot;~&gt; 2.0.0&quot; , only : [ :dev , :integration ] } , { :divo_redis , &quot;~&gt; 1.0.0&quot; , only : [ :dev , :integration ] } ] And in your config, include the imported dependency module(s) as a list of tuples along with any environment variables the stack takes as a keyword list #config/config.exs config :myapp , divo : [ { DivoRedis , [ initial_key : &quot;myapp:secret&quot; ] } ] , divo_wait : [ dwell : 700 , max_tries : 50 ] Known Modules: Kafka Redis Machinebox Method 3 - Elixir map #config/config.exs config :myapp , divo : %{ version : &quot;3&quot; , services : %{ redis : %{ image : &quot;redis:latest&quot; , ports : [ &quot;6379:6379&quot; ] , healthcheck : %{ test : [ &quot;CMD&quot; , &quot;redis-cli&quot; , &quot;PING&quot; ] , interval : &quot;5s&quot; , timeout : &quot;10s&quot; , retries : 3 } } } } , divo_wait : [ dwell : 700 , max_tries : 50 ] Split Unit and Integration Tests You will need to move any existing unit tests into a sub directory. We recommend the following structure: myapp └ ─ ─ test ├ ─ ─ integration │     ├ ─ ─ myapp_test . exs │     └ ─ ─ test_helper . exs └ ─ ─ unit ├ ─ ─ module_a_test . exs ├ ─ ─ module_b_test . exs └ ─ ─ test_helper . exs NOTE: test_helper.exs must be included in the root of both integration and unit tests. Test Paths Add this to your mix.exs to ensure that your unit and integration tests run in isolation from each other. #mix.exs def project do [ # ... test_paths : test_paths ( Mix . env ( ) ) ] end # ... defp test_paths ( :integration ) , do : [ &quot;test/integration&quot; ] defp test_paths ( _ ) , do : [ &quot;test/unit&quot; ] Use Divo in an Integration Test In each integration module add: use Divo Divo will then take care of running docker-compose up before running your tests and then run docker-compose down after they've completed. NOTE: Divo will start and stop docker-compose for every integration test module, unless the &quot;DIVO_DOWN&quot; environment variable is set to &quot;DISABLED&quot;. Example Integration Test Module using redix : defmodule MyAppTest do use ExUnit.Case use Divo test &quot;persisting and reading from redis&quot; do { :ok , conn } = Redix . start_link ( host : &quot;localhost&quot; , port : 6379 ) Redix . command ( conn , [ &quot;SET&quot; , &quot;mykey&quot; , &quot;foo&quot; ] ) { :ok , result } = Redix . command ( conn , [ &quot;GET&quot; , &quot;mykey&quot; ] ) assert result === &quot;foo&quot; end end Use Divo for the entire test suite In your integration or test suite's test_helper.exs file add Divo.Suite.start() before ExUnit.start() Example: Divo.Suite . start ( ) ... ExUnit . start ( ) This will make Divo stand up dockers that last the entire run of the test suite (or just a few modules or tests if you specified them in your mix test.integration command). It will wire itself up to tear down the dockers if in cases where the tests fail to compile. Ideally, you will want to NOT have use Divo in your tests. However, if you leave use Divo in for all of the tests, and still add the start to your test_helper.exs the tests will still run as expected, with an additional docker start and stop wrapped around the whole run. The Divo.Suite.start function takes all of the options that use Divo does plus a few extras for controlling where the final docker cleanup occurs: auto_cleanup? - whether or not to cleanup dockers on program exit. Defaults to true Whether or not you choose to let it cleanup after itself, Divo.Suite.start will return a zero-arity cleanup hook that you can call when you want to explicitly cleanup the dockers. Divo.Suite . start ( ) |&gt; on_exit ( ) Running Integration Tests Integration tests are executed by running: mix test.integration License Released under Apache 2 license .","ref":"Divo.html","title":"Divo","type":"module"},{"doc":"Implements a macro for including directly in integration test files. Add use Divo to an integration test file to automatically add the Start and Kill commands for your dependent service definitions to a setup_all block of your tests.","ref":"Divo.html#__using__/1","title":"Divo.__using__/1","type":"macro"},{"doc":"","ref":"Divo.html#cleanup/1","title":"Divo.cleanup/1","type":"function"},{"doc":"See Divo.Compose.kill/0 .","ref":"Divo.html#kill/0","title":"Divo.kill/0","type":"function"},{"doc":"See Divo.Compose.run/1 .","ref":"Divo.html#run/1","title":"Divo.run/1","type":"function"},{"doc":"","ref":"Divo.html#start/1","title":"Divo.start/1","type":"function"},{"doc":"See Divo.Compose.stop/0 .","ref":"Divo.html#stop/0","title":"Divo.stop/0","type":"function"},{"doc":"Can be used in place of Divo to also include ExUnit.Case. Opts will still be passed to Divo as normal, and the async opt will be passed only to ExUnit.Case.","ref":"Divo.Case.html","title":"Divo.Case","type":"module"},{"doc":"Implements the basic docker-compose commands for running from your mix tasks. Run, stop, and kill container services. These operations only apply to services managed by Divo, i.e. defined in your Mix.env file under the :myapp, :divo key.","ref":"Divo.Compose.html","title":"Divo.Compose","type":"module"},{"doc":"Builds and/or validates the compose file and executes the docker-compose down call to stop the containerized services and removes all resources created by the compose file such as containers, networks, and volumes.","ref":"Divo.Compose.html#kill/0","title":"Divo.Compose.kill/0","type":"function"},{"doc":"Builds and/or validates the compose file and executes the docker-compose up call to start the entirety of the defined stack or a subset of the services defined in the stack based on supplying an optional list of service keys.","ref":"Divo.Compose.html#run/1","title":"Divo.Compose.run/1","type":"function"},{"doc":"Builds and/or validates the compose file and executes the docker-compose stop call to stop the containerized services without removing the resources created by the compose file.","ref":"Divo.Compose.html#stop/0","title":"Divo.Compose.stop/0","type":"function"},{"doc":"Constructs the ad hoc docker-compose file used by Divo to run docker dependency services based on config in the app environment ( Mix.env() ) file.","ref":"Divo.File.html","title":"Divo.File","type":"module"},{"doc":"Passes through the file name when the compose file is pre-existing and supplied via file system path. Builds and writes a dynamic compose file to a temp directory before returning the path to that temp file if file does not exist.","ref":"Divo.File.html#ensure_file/1","title":"Divo.File.ensure_file/1","type":"function"},{"doc":"Returns the name of the compose file to run, either as a pass-through from an existing compose file or the path of the file dynamically created by Divo.","ref":"Divo.File.html#file_name/0","title":"Divo.File.file_name/0","type":"function"},{"doc":"Extract common key-fetching functionality used by all of the mix tasks to construct the proper arguments to the docker commands.","ref":"Divo.Helper.html","title":"Divo.Helper","type":"module"},{"doc":"Returns the configuration for divo from the environment config exs file that defines the container services to run or the path to the config given an existing compose file.","ref":"Divo.Helper.html#fetch_config/0","title":"Divo.Helper.fetch_config/0","type":"function"},{"doc":"Returns the name of the calling app from the mix config.","ref":"Divo.Helper.html#fetch_name/0","title":"Divo.Helper.fetch_name/0","type":"function"},{"doc":"Implements a behaviour for importing predefined compose stacks from external library complementary to divo for quickly standing up well-defined services with little variation in configuration.","ref":"Divo.Stack.html","title":"Divo.Stack","type":"behaviour"},{"doc":"Iterates over modules supplied in the app :divo config, calling the gen_stack function on each module's implementation of the behavior, collecting the resulting maps into a single map and passing the accumulated result out for writing out the file.","ref":"Divo.Stack.html#concat_compose/1","title":"Divo.Stack.concat_compose/1","type":"function"},{"doc":"Defines the behaviour that must be implemented to supply configs from external modules to divo. The configuration values are expected as a keyword list of attributes specific to each module adopting the behaviour.","ref":"Divo.Stack.html#c:gen_stack/1","title":"Divo.Stack.gen_stack/1","type":"callback"},{"doc":"Implements a validation of the compose file structure, either constructed by divo or supplied by as an existing compose file.","ref":"Divo.Validate.html","title":"Divo.Validate","type":"module"},{"doc":"Wraps the function of docker-compose to validate the structure of the compose file for correct format/syntax and required keys are supplied.","ref":"Divo.Validate.html#validate/1","title":"Divo.Validate.validate/1","type":"function"},{"doc":"Executes docker-compose down with your :divo configuration.","ref":"Mix.Tasks.Docker.Kill.html","title":"Mix.Tasks.Docker.Kill","type":"task"},{"doc":"Executes docker-compose up with your :divo configuration.","ref":"Mix.Tasks.Docker.Start.html","title":"Mix.Tasks.Docker.Start","type":"task"},{"doc":"Executes docker-compose stop with your :divo configuration.","ref":"Mix.Tasks.Docker.Stop.html","title":"Mix.Tasks.Docker.Stop","type":"task"},{"doc":"Runs integration tests. This task will only work if your project has been configured according to the configuration steps provided in Divo .","ref":"Mix.Tasks.Test.Integration.html","title":"Mix.Tasks.Test.Integration","type":"task"},{"doc":"Getting Started Easily run Elixir integration tests with docker-compose. Provide Divo with docker-compose configuration, add use Divo to your integration tests, and run with mix test.integration .","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding divo to your list of dependencies in mix.exs : def deps ( ) do [ { :divo , &quot;~&gt; 2.0.0&quot; , only : [ :dev , :integration ] } ] end The docs can be found at https://hexdocs.pm/divo . New versions are published with actions upon github release.","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Docker Define services in your mix configuration file to define the dockerized service(s) you want to run as a dependency of your Elixir app. Define divo config in one of the following three ways: Method 1 - Compose file In your config, include the path to the yaml or json-formatted compose file #config/config.exs config :myapp , divo : &quot; test / support / docker - compose . yaml , divo_wait : [ dwell : 700 , max_tries : 50 ] #test/support/docker-compose.yaml version: '3' services: redis: image: redis ports: - &quot;6379:6379&quot; healthcheck: test: [&quot;CMD&quot;, &quot;redis-cli&quot;, &quot;PING&quot;] interval: 5s timeout: 10s retries: 3 Method 2 - Pre-existing module In your mix file, include the additional dependency #mix.exs def deps ( ) do [ { :divo , &quot;~&gt; 2.0.0&quot; , only : [ :dev , :integration ] } , { :divo_redis , &quot;~&gt; 1.0.0&quot; , only : [ :dev , :integration ] } ] And in your config, include the imported dependency module(s) as a list of tuples along with any environment variables the stack takes as a keyword list #config/config.exs config :myapp , divo : [ { DivoRedis , [ initial_key : &quot;myapp:secret&quot; ] } ] , divo_wait : [ dwell : 700 , max_tries : 50 ] Known Modules: Kafka Redis Machinebox Method 3 - Elixir map #config/config.exs config :myapp , divo : %{ version : &quot;3&quot; , services : %{ redis : %{ image : &quot;redis:latest&quot; , ports : [ &quot;6379:6379&quot; ] , healthcheck : %{ test : [ &quot;CMD&quot; , &quot;redis-cli&quot; , &quot;PING&quot; ] , interval : &quot;5s&quot; , timeout : &quot;10s&quot; , retries : 3 } } } } , divo_wait : [ dwell : 700 , max_tries : 50 ] Split Unit and Integration Tests You will need to move any existing unit tests into a sub directory. We recommend the following structure: myapp └ ─ ─ test ├ ─ ─ integration │     ├ ─ ─ myapp_test . exs │     └ ─ ─ test_helper . exs └ ─ ─ unit ├ ─ ─ module_a_test . exs ├ ─ ─ module_b_test . exs └ ─ ─ test_helper . exs NOTE: test_helper.exs must be included in the root of both integration and unit tests. Test Paths Add this to your mix.exs to ensure that your unit and integration tests run in isolation from each other. #mix.exs def project do [ # ... test_paths : test_paths ( Mix . env ( ) ) ] end # ... defp test_paths ( :integration ) , do : [ &quot;test/integration&quot; ] defp test_paths ( _ ) , do : [ &quot;test/unit&quot; ] Use Divo in an Integration Test In each integration module add: use Divo Divo will then take care of running docker-compose up before running your tests and then run docker-compose down after they've completed. NOTE: Divo will start and stop docker-compose for every integration test module, unless the &quot;DIVO_DOWN&quot; environment variable is set to &quot;DISABLED&quot;. Example Integration Test Module using redix : defmodule MyAppTest do use ExUnit.Case use Divo test &quot;persisting and reading from redis&quot; do { :ok , conn } = Redix . start_link ( host : &quot;localhost&quot; , port : 6379 ) Redix . command ( conn , [ &quot;SET&quot; , &quot;mykey&quot; , &quot;foo&quot; ] ) { :ok , result } = Redix . command ( conn , [ &quot;GET&quot; , &quot;mykey&quot; ] ) assert result === &quot;foo&quot; end end","ref":"readme.html#configuration","title":"README - Configuration","type":"extras"},{"doc":"In your integration or test suite's test_helper.exs file add Divo.Suite.start() before ExUnit.start() Example: Divo.Suite . start ( ) ... ExUnit . start ( ) This will make Divo stand up dockers that last the entire run of the test suite (or just a few modules or tests if you specified them in your mix test.integration command). It will wire itself up to tear down the dockers if in cases where the tests fail to compile. Ideally, you will want to NOT have use Divo in your tests. However, if you leave use Divo in for all of the tests, and still add the start to your test_helper.exs the tests will still run as expected, with an additional docker start and stop wrapped around the whole run. The Divo.Suite.start function takes all of the options that use Divo does plus a few extras for controlling where the final docker cleanup occurs: auto_cleanup? - whether or not to cleanup dockers on program exit. Defaults to true Whether or not you choose to let it cleanup after itself, Divo.Suite.start will return a zero-arity cleanup hook that you can call when you want to explicitly cleanup the dockers. Divo.Suite . start ( ) |&gt; on_exit ( )","ref":"readme.html#use-divo-for-the-entire-test-suite","title":"README - Use Divo for the entire test suite","type":"extras"},{"doc":"Integration tests are executed by running: mix test.integration","ref":"readme.html#running-integration-tests","title":"README - Running Integration Tests","type":"extras"},{"doc":"Released under Apache 2 license .","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Docker Compose instructions are passed to the docker-compose binary on your Docker engine host as either a yaml- or json-formatted document with maps defining the container services, networks, and volumes needed to run the services as an interconnected stack of components (as well as a compose file version). The keys in the underlying map structure generally have a one-to-one relationship to the various arguments available to the docker run command. For more details, see the full docker compose documentation","ref":"docker-compose.html","title":"Docker Compose","type":"extras"},{"doc":"","ref":"additional-configuration.html","title":"Additional Configuration","type":"extras"},{"doc":"Sometimes services take a moment to start up and Elixir apps tend to start (and attempt to run their tests) too quickly for their dependencies to be ready. For those situations, add the key :divo_wait to the app config that defines a wait period in milliseconds and a maximum number of tries to check for the containerized services to be healthy before aborting. In order for the wait to hold execution for the containers to register as healthy with the Docker engine, a healthcheck must be built into the Dockerfile for the image or defined in the compose file. config :myapp , divo : &quot;test/support/docker-compose.yaml&quot; , divo_wait : [ dwell : 700 , max_tries : 50 ]","ref":"additional-configuration.html#divo-wait","title":"Additional Configuration - Divo Wait","type":"extras"}]